<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_InsuranceElement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_InsuranceElement extends AbstractStructArrayBase
{
    /**
     * The InsuranceElement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_InsuranceElement[]
     */
    public $InsuranceElement;
    /**
     * Constructor method for ArrayOfJP_InsuranceElement
     * @uses ArrayOfJP_InsuranceElement::setInsuranceElement()
     * @param \StructType\JP_InsuranceElement[] $insuranceElement
     */
    public function __construct(array $insuranceElement = array())
    {
        $this
            ->setInsuranceElement($insuranceElement);
    }
    /**
     * Get InsuranceElement value
     * @return \StructType\JP_InsuranceElement[]|null
     */
    public function getInsuranceElement()
    {
        return $this->InsuranceElement;
    }
    /**
     * This method is responsible for validating the values passed to the setInsuranceElement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInsuranceElement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInsuranceElementForArrayConstraintsFromSetInsuranceElement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_InsuranceElementInsuranceElementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_InsuranceElementInsuranceElementItem instanceof \StructType\JP_InsuranceElement) {
                $invalidValues[] = is_object($arrayOfJP_InsuranceElementInsuranceElementItem) ? get_class($arrayOfJP_InsuranceElementInsuranceElementItem) : sprintf('%s(%s)', gettype($arrayOfJP_InsuranceElementInsuranceElementItem), var_export($arrayOfJP_InsuranceElementInsuranceElementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InsuranceElement property can only contain items of type \StructType\JP_InsuranceElement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InsuranceElement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InsuranceElement[] $insuranceElement
     * @return \ArrayType\ArrayOfJP_InsuranceElement
     */
    public function setInsuranceElement(array $insuranceElement = array())
    {
        // validation for constraint: array
        if ('' !== ($insuranceElementArrayErrorMessage = self::validateInsuranceElementForArrayConstraintsFromSetInsuranceElement($insuranceElement))) {
            throw new \InvalidArgumentException($insuranceElementArrayErrorMessage, __LINE__);
        }
        $this->InsuranceElement = $insuranceElement;
        return $this;
    }
    /**
     * Add item to InsuranceElement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InsuranceElement $item
     * @return \ArrayType\ArrayOfJP_InsuranceElement
     */
    public function addToInsuranceElement(\StructType\JP_InsuranceElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_InsuranceElement) {
            throw new \InvalidArgumentException(sprintf('The InsuranceElement property can only contain items of type \StructType\JP_InsuranceElement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InsuranceElement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_InsuranceElement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_InsuranceElement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_InsuranceElement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_InsuranceElement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_InsuranceElement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InsuranceElement
     */
    public function getAttributeName()
    {
        return 'InsuranceElement';
    }
}
